SoIntersectionDetectionAction Class Reference
Action Classes

The SoIntersectionDetectionAction class is for detecting intersecting primitives in a scene. More...

`#include <Inventor/collision/SoIntersectionDetectionAction.h>`

Inheritance diagram for SoIntersectionDetectionAction:

## Public Types

enum | Resp { NEXT_PRIMITIVE , NEXT_SHAPE , ABORT }
typedef SoCallbackAction::Response | SoIntersectionVisitationCB(void *closure, const SoPath *where)
typedef SbBool | SoIntersectionFilterCB(void *closure, const SoPath *p1, const SoPath *p2)
typedef Resp | SoIntersectionCB(void *closure, const SoIntersectingPrimitive *p1, const SoIntersectingPrimitive *p2)
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }

## Public Member Functions

virtual SoType | getTypeId (void) const
void | setIntersectionDetectionEpsilon (float epsilon)
float | getIntersectionDetectionEpsilon (void) const
void | setTypeEnabled (SoType type, SbBool enable)
SbBool | isTypeEnabled (SoType type, SbBool checkgroups=FALSE) const
void | setManipsEnabled (SbBool enable)
SbBool | isManipsEnabled (void) const
void | setDraggersEnabled (SbBool enable)
SbBool | isDraggersEnabled (void) const
void | setShapeInternalsEnabled (SbBool enable)
SbBool | isShapeInternalsEnabled (void) const
void | addVisitationCallback (SoType type, SoIntersectionVisitationCB *cb, void *closure)
void | removeVisitationCallback (SoType type, SoIntersectionVisitationCB *cb, void *closure)
virtual void | apply (SoNode *node)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &paths, SbBool obeysRules=FALSE)
virtual void | setFilterCallback (SoIntersectionFilterCB *cb, void *closure=NULL)
virtual void | addIntersectionCallback (SoIntersectionCB *cb, void *closure=NULL)
virtual void | removeIntersectionCallback (SoIntersectionCB *cb, void *closure=NULL)
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
static void | setIntersectionEpsilon (float epsilon)
static float | getIntersectionEpsilon (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions

virtual const SoEnabledElementsList & | getEnabledElements (void) const
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | beginTraversal (SoNode *node)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions

static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members

Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoIntersectionDetectionAction class is for detecting intersecting primitives in a scene.

Note that only collisions between actual geometry in the scene are detected, so the contents of some special nodes like e.g. SoText2 and SoImage (which projects to screen-plane bitmap graphics, and not actual polygons) will not be considered for collision detection.

Note also that the SoIntersectionDetectionAction class is not a high-performance component in Coin. Using it in a continuous manner over complex scene graphs is doomed to be a performance killer.

Below is a simple usage example for this class. It was written as a standalone framework set up for profiling and optimization of the SoIntersectionDetectionAction. It tests intersection of all shapes against each other for the loaded file.

#include <cstdlib>
#include <Inventor/SbTime.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/collision/SoIntersectionDetectionAction.h>
#include <Inventor/errors/SoDebugError.h>
#include <Inventor/nodekits/SoNodeKit.h>
#include <Inventor/nodes/SoSeparator.h>
static SoIntersectionDetectionAction::Resp
intersectionCB(void * closure,
const SoIntersectingPrimitive * pr1,
const SoIntersectingPrimitive * pr2)
{
(void)fprintf(stdout, "intersection hit!\n");
return SoIntersectionDetectionAction::NEXT_PRIMITIVE;
}
int
main(int argc, char ** argv)
{
SoDB::init();
SoNodeKit::init();
SoInteraction::init();
if (argc != 2) {
(void)fprintf(stderr, "\n\tUsage: testapp <filename.iv>\n\n");
exit(1);
}
SoInput in;
SbBool ok = in.openFile(argv[1]);
assert(ok);
SoSeparator * root = SoDB::readAll(&in);
assert(root);
root->ref();
SoIntersectionDetectionAction ida;
ida.addIntersectionCallback(intersectionCB, NULL);
ida.setManipsEnabled(FALSE);
ida.setDraggersEnabled(FALSE);
ida.setIntersectionDetectionEpsilon(10.0f);
SbTime starttime = SbTime::getTimeOfDay();
SoDebugError::postInfo("main", "SoIntersectionDetectionAction::apply");
ida.apply(root);
SoDebugError::postInfo("main", "apply() done after %f seconds.",
(SbTime::getTimeOfDay() - starttime).getValue());
root->unref();
return 0;
}
SbTime::getTimeOfDay
static SbTime getTimeOfDay(void)
Definition SbTime.cpp:148
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoDB::readAll
static SoSeparator * readAll(SoInput *input)
Definition SoDB.cpp:682
SoDB::init
static void init(void)
Definition SoDB.cpp:200
SoDebugError::postInfo
static void postInfo(const char *const source, const char *const format,...)
Definition SoDebugError.cpp:412
SoInput::openFile
virtual SbBool openFile(const char *fileName, SbBool okIfNotFound=FALSE)
Definition SoInput.cpp:495
SoInteraction::init
static void init(void)
Definition SoInteraction.cpp:127
SoIntersectionDetectionAction::setIntersectionDetectionEpsilon
void setIntersectionDetectionEpsilon(float epsilon)
Definition SoIntersectionDetectionAction.cpp:375
SoIntersectionDetectionAction::apply
virtual void apply(SoNode *node)
Definition SoIntersectionDetectionAction.cpp:658
SoIntersectionDetectionAction::setManipsEnabled
void setManipsEnabled(SbBool enable)
Definition SoIntersectionDetectionAction.cpp:459
SoIntersectionDetectionAction::setDraggersEnabled
void setDraggersEnabled(SbBool enable)
Definition SoIntersectionDetectionAction.cpp:494
SoIntersectionDetectionAction::addIntersectionCallback
virtual void addIntersectionCallback(SoIntersectionCB *cb, void *closure=NULL)
Definition SoIntersectionDetectionAction.cpp:628
SoNodeKit::init
static void init(void)
Definition SoNodeKit.cpp:87
SoIntersectingPrimitive
Struct with collision information.
Definition SoIntersectionDetectionAction.h:41

Since
  Coin 2.1
  TGS Inventor 2.4

## Member Function Documentation

## getTypeId()

SoType SoIntersectionDetectionAction::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Implements SoAction.

## getClassTypeId()

SoType SoIntersectionDetectionAction::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## addMethod()

void SoIntersectionDetectionAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## enableElement()

void SoIntersectionDetectionAction::enableElement | ( | const SoType | type,
|  | const int | stackindex )

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## getEnabledElements()

const SoEnabledElementsList & SoIntersectionDetectionAction::getEnabledElements | ( | void |  | ) | const

protected virtual

Returns list of enabled elements.

Reimplemented from SoAction.

## getClassEnabledElements()

SoEnabledElementsList * SoIntersectionDetectionAction::getClassEnabledElements | ( | void |  | ) |

static protected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## getClassActionMethods()

SoActionMethodList * SoIntersectionDetectionAction::getClassActionMethods | ( | void |  | ) |

static protected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## setIntersectionDetectionEpsilon()

void SoIntersectionDetectionAction::setIntersectionDetectionEpsilon | ( | float | epsilon | ) |

Sets the intersection detection distance epsilon value for the action object. This overrides the global value.

See also SoIntersectionDetectionAction::setIntersectionEpsilon() for important information about how this setting influences performance.

## getIntersectionDetectionEpsilon()

float SoIntersectionDetectionAction::getIntersectionDetectionEpsilon | ( | void |  | ) | const

Returns the set intersection detection distance epsilon value for the action object.

## setIntersectionEpsilon()

void SoIntersectionDetectionAction::setIntersectionEpsilon | ( | float | epsilon | ) |

static

Sets the global intersection detection distance epsilon value.

This makes primitives within the epsilon distance be considered to intersect each other.

This will affect all intersection detection action objects in use that don't have a locally set value.

The epsilon value is a world space value.

Be aware that increasing the epsilon value can dramatically increase the number of primitive intersection tests being done to decide intersections. Increasing the epsilon value can therefore cause serious slow-downs in the running time of the intersections checks.

## getIntersectionEpsilon()

float SoIntersectionDetectionAction::getIntersectionEpsilon | ( | void |  | ) |

static

Returns the globally set intersection detection distance epsilon value.

## setTypeEnabled()

void SoIntersectionDetectionAction::setTypeEnabled | ( | SoType | type,
|  | SbBool | enable )

Sets whether nodes of specific types (including derived objects) should be tested for intersection or not.

See also
  isTypeEnabled(), setManipsEnabled(), setDraggersEnabled()

## isTypeEnabled()

SbBool SoIntersectionDetectionAction::isTypeEnabled | ( | SoType | type,
|  | SbBool | checkgroups = FALSE ) const

Returns whether nodes of specific types are enabled or not. The checkgroups argument can be set to TRUE if you want the return value to reflect whether the node will be implicit enabled/disabled through the settings controlled by the setManipsEnabled() and setDraggersEnabled() functions.

The default is that all node types are enabled.

Note that derivation checks are not performed - the type needs to be the exact same type as has been disabled with setTypeEnabled()

See also
  setTypeEnabled()

## setManipsEnabled()

void SoIntersectionDetectionAction::setManipsEnabled | ( | SbBool | enable | ) |

Sets whether manipulators in the scene graph should be tested for intersection with other geometry or not.

Note that when draggers are disabled with setDraggersEnabled(), this setting has no effect - manipulators are disabled too.

See also
  isManipsEnabled(), setDraggersEnabled(), setTypeEnabled()

## isManipsEnabled()

SbBool SoIntersectionDetectionAction::isManipsEnabled | ( | void |  | ) | const

Returns whether the actions is set up to test intersection on manipulators in the scene or not.

Note that when draggers are disabled with setDraggersEnabled(), this setting has no effect - manipulators are disabled too.

The default is that manipulators are enabled for intersection testing with other geometry in the scene.

See also
  setManipsEnabled()

## setDraggersEnabled()

void SoIntersectionDetectionAction::setDraggersEnabled | ( | SbBool | enable | ) |

Sets whether draggers in the scene graph should be tested for intersection with other geometry or not.

Note that when you disable draggers, manipulators are also automatically disabled, although the isManipsDisabled() setting might reflect otherwise.

See also
  isDraggersEnabled(), setManipsEnabled(), setTypeEnabled()

## isDraggersEnabled()

SbBool SoIntersectionDetectionAction::isDraggersEnabled | ( | void |  | ) | const

Returns whether the actions is set up to test intersection on draggers in the scene or not.

The default is that draggers are enabled for intersection testing with other geometry in the scene.

See also
  setDraggersEnabled()

## setShapeInternalsEnabled()

void SoIntersectionDetectionAction::setShapeInternalsEnabled | ( | SbBool | enable | ) |

Sets whether nodes in the scene graph should be checked for intersecting primitives within themselves.

Default is `FALSE`.

See also
  isShapeInternalsEnabled()

## isShapeInternalsEnabled()

SbBool SoIntersectionDetectionAction::isShapeInternalsEnabled | ( | void |  | ) | const

Returns whether nodes in the scene graph will be checked for intersecting primitives within themselves.

The default value for this setting is `FALSE`.

See also
  setShapeInternalsEnabled()

## addVisitationCallback()

void SoIntersectionDetectionAction::addVisitationCallback | ( | SoType | type,
|  | SoIntersectionVisitationCB * | cb,
|  | void * | closure )

The scene graph traversal can be controlled with callbacks which you set with this method. Use just like you would use SoCallbackAction::addPreCallback().

See also
  SoCallbackAction::addPreCallback()

## removeVisitationCallback()

void SoIntersectionDetectionAction::removeVisitationCallback | ( | SoType | type,
|  | SoIntersectionVisitationCB * | cb,
|  | void * | closure )

The scene graph traversal can be controlled with callbacks which you remove with this method. Use just like you would use SoCallbackAction::removePreCallback().

See also
  SoCallbackAction::removePreCallback()

## apply() [1/3]

void SoIntersectionDetectionAction::apply | ( | SoNode * | root | ) |

virtual

Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

## apply() [2/3]

void SoIntersectionDetectionAction::apply | ( | SoPath * | path | ) |

virtual

Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

## apply() [3/3]

void SoIntersectionDetectionAction::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE )

virtual

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
  SoAction::apply(SoPath * path)

Reimplemented from SoAction.

## setFilterCallback()

void SoIntersectionDetectionAction::setFilterCallback | ( | SoIntersectionFilterCB * | cb,
|  | void * | closure = NULL )

virtual

This callback is called when two shapes are found to have intersecting bounding boxes, and are about to be checked for real intersection between their primitives.

When intersection epsilon values are in use, bounding box intersection testing is done approximately and will trigger the filter callback on boxes that are further from each other than the epsilon length.

If the callback returns TRUE, the intersection test will be performed. If the callback returns FALSE, the intersection testing will be skipped.

The API allows only one filter callback.

## addIntersectionCallback()

void SoIntersectionDetectionAction::addIntersectionCallback | ( | SoIntersectionCB * | cb,
|  | void * | closure = NULL )

virtual

Adds a callback to be called when two intersecting primitives are found in the scene.

If the callback returns ABORT, the intersection detection is aborted. If the callback returns NEXT_SHAPE, the intersection detection between these two shapes are aborted and the action continues checking other shapes. If the callback returns NEXT_PRIMITIVE, the intersection detection testing continues checking the other primitives in these two shapes.

See also
  removeIntersectionCallback()

## removeIntersectionCallback()

void SoIntersectionDetectionAction::removeIntersectionCallback | ( | SoIntersectionCB * | cb,
|  | void * | closure = NULL )

virtual

Removes a callback set with addIntersectionCallback().

See also
  addIntersectionCallback()

The documentation for this class was generated from the following files:

- SoIntersectionDetectionAction.h
- SoIntersectionDetectionAction.cpp